;;  Trace of Particles Effect
;; Shuji Narazaki (narazaki@InetQ.or.jp)
;; Time-stamp: <97/03/15 17:27:33 narazaki@InetQ.or.jp>
;; Version 0.2


;; Bearbeitet für GIMP 2.10.x
;; Texte übersetzt ins Deutsche

(define (apply-t-o-p-logo-effect img
                                 logo-layer
                                 b-size
                                 hit-rate
                                 edge-size
                                 edge-only
                                 base-color
                                 bg-color)
  (let* (
        (width (car (gimp-drawable-width logo-layer)))
        (height (car (gimp-drawable-height logo-layer)))
        (logo-layer-mask (car (gimp-layer-create-mask logo-layer ADD-BLACK-MASK)))
        (sparkle-layer (car (gimp-layer-new img width height RGBA-IMAGE "Sparkle" 100 LAYER-MODE-NORMAL-LEGACY)))
        (shadow-layer (car (gimp-layer-new img width height RGBA-IMAGE "Shadow" 90 LAYER-MODE-ADDITION-LEGACY)))
        (bg-layer (car (gimp-layer-new img width height RGB-IMAGE "Background" 100 LAYER-MODE-NORMAL-LEGACY)))
        (selection 0)
        (white '(255 255 255))
        )

    (gimp-context-push)
    (gimp-context-set-defaults)

    (script-fu-util-image-resize-from-layer img logo-layer)
    (script-fu-util-image-add-layers img sparkle-layer shadow-layer bg-layer)
    (gimp-selection-none img)
    (gimp-drawable-edit-clear shadow-layer)
    (gimp-drawable-edit-clear sparkle-layer)
    (gimp-context-set-background base-color)
    (gimp-context-set-opacity 100)
    (gimp-context-set-paint-mode 0) ; 0 = LAYER-MODE-NORMAL-LEGACY
    (gimp-drawable-edit-fill sparkle-layer FILL-BACKGROUND)
    (gimp-image-select-item img CHANNEL-OP-REPLACE logo-layer)
    (set! selection (car (gimp-selection-save img)))
    (gimp-selection-grow img edge-size)
    (plug-in-noisify RUN-NONINTERACTIVE img sparkle-layer FALSE
                     (* 0.1 hit-rate) (* 0.1 hit-rate) (* 0.1 hit-rate) 0.0)
    (gimp-selection-border img edge-size)
    (plug-in-noisify RUN-NONINTERACTIVE img sparkle-layer FALSE hit-rate hit-rate hit-rate 0.0)
    (gimp-selection-none img)
    (plug-in-sparkle 
    RUN-NONINTERACTIVE 
    img 
    sparkle-layer 
    0.03 ;Luminosity threshold (0.0 - 1.0)
    0.39 ; Flare intensity (0.0 - 1.0) zurueckgesetzt von 0.49
    width 
    6 ; spikes
    15 ; Spike angle (0-360 degrees, -1: random)
    0.60 ; Spike density (0.0 - 1.0) zurueckgesetzt von 1.0
    0.0 0.0 0.0 
    FALSE ; Preserve luminosity (TRUE/FALSE)
    FALSE FALSE     
    0
    )
    (gimp-image-select-item img CHANNEL-OP-REPLACE selection)
    (gimp-selection-shrink img edge-size)
    (gimp-drawable-levels 
    sparkle-layer ; drawable
    0 ; channel
    0 ; low-in   
    1 ; high-in
    0 ; clamp-input
    1.1 ; gamma war 1.2
    0 ; low-out
    1 ; high-out
    0 ; clamp-output
    )
    (gimp-image-select-item img CHANNEL-OP-REPLACE selection)
    (gimp-selection-border img edge-size)
    (gimp-drawable-levels 
    sparkle-layer ; drawable
    0 ; channel
    0 ; low-in
    1 ; high-in
    0 ; clamp-input
    0.7 ; gamma war 0.5
    0 ; low-out
    1 ; high-out
    0 ; clamp-output
    )
    (gimp-image-select-item img CHANNEL-OP-REPLACE selection)
    (gimp-selection-grow img (/ edge-size 2.0))
    (gimp-selection-invert img)
    (gimp-drawable-edit-clear sparkle-layer)
    (if (= edge-only TRUE)
        (begin
          (gimp-image-select-item img CHANNEL-OP-REPLACE selection)
          (gimp-selection-shrink img (/ edge-size 2.0))
          (gimp-drawable-edit-clear sparkle-layer)
          (gimp-image-select-item img CHANNEL-OP-REPLACE selection)
          (gimp-selection-grow img (/ edge-size 2.0))
          (gimp-selection-invert img)
        )          
    )
    (gimp-context-set-foreground '(0 0 0))
    (gimp-context-set-background '(255 255 255))
;    (gimp-context-set-brush "Circle Fuzzy (11)") ; warum? wird doch nicht benutzt
    (gimp-selection-feather img b-size)
    (gimp-drawable-edit-fill shadow-layer FILL-BACKGROUND)

    (gimp-selection-none img)
    (gimp-context-set-background base-color) ; war bg-color
    (gimp-drawable-edit-fill bg-layer FILL-BACKGROUND)

    (gimp-item-set-visible logo-layer 0)
    (gimp-image-set-active-layer img sparkle-layer)

    (gimp-context-pop)
  )
) ; end: define


; hier beginnt Script für erstellen ....
(define (script-fu-t-o-p-logo-alpha img
                                    logo-layer
                                    b-size
                                    hit-rate
                                    edge-size
                                    edge-only
                                    base-color
                                    bg-color)
  (begin
    (gimp-image-undo-group-start img)
    (apply-t-o-p-logo-effect img logo-layer b-size hit-rate
                             edge-size edge-only base-color bg-color)
    (gimp-image-undo-group-end img)
    (gimp-displays-flush)
  )
) ;  end: define für erstellen

(script-fu-register "script-fu-t-o-p-logo-alpha"
  _"_Partikelspur..."
  _"Einen Partikelspureffekt zu einem ausgewählten Bereich (oder Alpha) hinzufügen"
  "Shuji Narazaki (narazaki@InetQ.or.jp)"
  "Shuji Narazaki"
  "1997"
  "RGBA"
  SF-IMAGE      "Image"                 0
  SF-DRAWABLE   "Drawable"              0
  SF-ADJUSTMENT _"Zellengröße (pixels)" '(20 1 200 1 10 0 1)
  SF-ADJUSTMENT _"Trefferrate"             '(0.2 0 1 .01 .01 2 0)
  SF-ADJUSTMENT _"Kantenbreite"           '(2 0 128 1 1 0 0)
  SF-TOGGLE     _"Nur Kanten"            FALSE
  SF-COLOR      _"Grundfarbe"           '(0 40 0)
  SF-COLOR      _"Hintergrundfarbe"     "white"
)

(script-fu-menu-register "script-fu-t-o-p-logo-alpha"
                         "<Image>/Filters/Alpha to Logo")


(define (script-fu-t-o-p-logo text
                              size
                              fontname
                              hit-rate
                              edge-size
                              edge-only
                              base-color
                              bg-color)
  (let* ((img (car (gimp-image-new 256 256 RGB)))
         (border (/ size 5))
         (text-layer (car (gimp-text-fontname img -1 0 0 text (* border 2) TRUE size PIXELS fontname))))
    (gimp-image-undo-disable img)
    (apply-t-o-p-logo-effect img text-layer border hit-rate
                             edge-size edge-only base-color bg-color)
    (gimp-image-undo-enable img)
    (gimp-display-new img)
  )
)

(script-fu-register "script-fu-t-o-p-logo"
  _"_Partikelspur..."
  _"Ein Logo mit einem Partikelspureffekt erzeugen"
  "Shuji Narazaki (narazaki@InetQ.or.jp)"
  "Shuji Narazaki"
  "1997"
  ""
  SF-STRING     _"Text"               "GIMP"
  SF-ADJUSTMENT _"Schriftgröße (Pixel)" '(100 1 1000 1 10 0 1)
  SF-FONT       _"Schrift"               "Becker"
  SF-ADJUSTMENT _"Trefferrate"           '(0.2 0 1 .01 .01 2 0)
  SF-ADJUSTMENT _"Kantenbreite"         '(2 0 128 1 1 0 0)
  SF-TOGGLE     _"Nur Kanten"          FALSE
  SF-COLOR      _"Grundfarbe"         '(0 40 0)
  SF-COLOR      _"Hintergrundfarbe"   "white"
)

(script-fu-menu-register "script-fu-t-o-p-logo"
                         "<Image>/File/Create/Logos")
